package sensorComponent;

import java.util.List;

import uk.ac.standrews.cs.nds.eventModel.ITimeStampedEvent;
import gamf.addons.apstractSystemAdapter.MetricExtractor;
import gamf.framework.MetricResult;
import gamf.framework.exceptions.ConfigurationError;
import gamf.framework.exceptions.EventStoreExecption;
import gamf.framework.exceptions.MetricExtractionException;
import gamf.interfaces.framework.IEventStore;
import gamf.interfaces.framework.IMetricResult;
import gamf.interfaces.systemAdapter.IMetricExtractor;

public class MySensorComponentMetricExtractor extends MetricExtractor implements
		IMetricExtractor {

	public MySensorComponentMetricExtractor() {
		super(Constants.SENSOR_METRIC_EXTRACTOR,
				Constants.SYSTEM_ADAPTER_CATEGORY);
	}

	/**
	 * extracts the number of errors during one observation period
	 */
	public IMetricResult extractMetricResult() throws MetricExtractionException {
		IEventStore events = null;
		try {
			events = gimmeEventStore();
		} catch (ConfigurationError e) {
			throw new MetricExtractionException(
					"could not access event store, check GAMF configuration!");
		}
		long oldestTimeStampOfInterest = System.currentTimeMillis()
				- Constants.OBSERVATION_PERIOD;

		List<ITimeStampedEvent> eventsOfInterest = null;
		try {
			eventsOfInterest = events.getLatestEventsOfType(
					Constants.ERROR_EVENT, oldestTimeStampOfInterest);
		} catch (EventStoreExecption e) {
			throw new MetricExtractionException(e);
		}

		int errorEvents = 0;
		if (eventsOfInterest != null) {
			errorEvents = eventsOfInterest.size();
		}

		IMetricResult metricResult = new MetricResult(
				Constants.SENSOR_METRIC_RESULT, errorEvents);

		// now we do some GAMF house keeping (optional)
		// nobody still needs the old events -> we clear the event store
		events.clear();

		return metricResult;
	}

}
